export const VersionModel = '2.0.4F';

export const CommandButtonList = {
  // 下发
  send: [
    // 2.2.1.读取工作强度映射表（0x0101）
    {id: '01', name:'读取工作强度映射表', enName: 'readWorkIntensityMapping', defaultSendData: /* '\xFE\x00\x07\x01\x01\x00\xFF' */'FE0007010100FF',
    response: 'FE000881016F6BFF',
    // 注意中间数据自行组装
    concat: {
      head: 'FE',
      len: '0007',
      command: '0101',
      foot: 'FF'
    }
  },
     // 2.2.2.设置设备工作强度映射表（0x0102）
     {id: '02',name:'设置工作强度映射表', enName: 'sendWorkIntensityMapping', defaultSendData: 'FE0007010203070a0d111416191b1eFF',concat: {
      head: 'FE',
      len: '0007',
      command: '0102',
      foot: 'FF'
    }},

     // 2.2.3.读取设备工作强度（0x0103）
     {id: '03',name:'读取设备工作强度', enName: 'readWorkIntensity', defaultSendData: 'FE0007010300FF',concat: {
      head: 'FE',
      len: '0007',
      command: '0103',
      foot: 'FF'
    }},

     // 2.2.4.设置设备工作强度（0x0104）
     {id: '04',name:'设置设备工作强度', enName: 'sendWorkIntensity', defaultSendData: 'FE000E01040102FF',concat: {
      head: 'FE',
      len: '000E',
      command: '0104',
      foot: 'FF'
    }},

     // 2.2.5.读取设备工作流程（0x0105）
     {id: '05',name:'读取设备工作流程', enName: 'readWorkProcess', defaultSendData: 'FE0007010500FF',concat: {
      head: 'FE',
      len: '0007',
      command: '0105',
      foot: 'FF'
    }},

     // 2.2.6.设置设备工作流程（0x0106）
     {id: '06',name:'设置设备工作流程', enName: 'sendWorkProcess', defaultSendData: 'FE00XX0016FF',concat: {
      head: 'FE',
      len: '00XX',
      command: '0106',
      foot: 'FF'
    }},
    // 2.2.7.设备启动工作（0x0107）
    {id: '07',name:'设备启动工作', enName: 'deviceStartWork', defaultSendData: 'FE00070107000000010060FF',concat: {
      head: 'FE',
      len: '0007',
      command: '0107',
      foot: 'FF'
    }},

    // 2.2.8设备停止工作（0x0108）
    {id: '08',name:'设备停止工作', enName: 'deviceStopWork', defaultSendData: 'FE0007010800000001FF',concat: {
      head: 'FE',
      len: '0007',
      command: '0108',
      foot: 'FF'
    }},

    // 2.2.9设备暂停工作（0x0109）
    {id: '09',name:'设备暂停工作', enName: 'devicePauseWork', defaultSendData: 'FE0007010900000001FF',concat: {
      head: 'FE',
      len: '0007',
      command: '0109',
      foot: 'FF'
    }},
    
    //2.2.10设备恢复工作（0x010A）
    {id: '10',name:'设备恢复工作', enName: 'deviceResumeWork', defaultSendData: 'FE0007010A00000001FF',concat: {
      head: 'FE',
      len: '0007',
      command: '010A',
      foot: 'FF'
    }},



    //2.2.11设置设备时钟（0x010B）
    {id: '11',concat: {
      head: 'FE',
      len: '0007',
      command: '010B',
      foot: 'FF'
    },name:'设置设备时钟', enName: 'sendDeviceClock', defaultSendData: '',},

    //2.2.12设备恢复出厂设置（0x010C）
    {id: '12',name:'设备恢复出厂设置', enName: 'deviceReset', defaultSendData: 'FE0007010C00FF',concat: {
      head: 'FE',
      len: '0007',
      command: '010C',
      foot: 'FF'
    }},

    

    

  ],
  // 上报，解析
  report: [
    // 设备上报版本号(0x0001)
    {cnName: '设备版本号', enName: 'deviceVersion', keyWord: '0001',response: 'FE000880016F6BFF'},


    // 设备上报电池电量(0x0002)
    {cnName: '设备电池电量', enName: 'deviceBattery', keyWord: '0002',response: 'FE000880026F6BFF'},

    // 设备上报充电状态(0x0003)
    {cnName: '设备充电状态', enName: 'deviceChargeState', keyWord: '0003',response: 'FE000880036F6BFF'},


    // 设备上报极片工作状态(0x0004)
    {cnName: '设备极片工作状态', enName: 'devicePoleWorkState', keyWord: '0004',response: 'FE000880046F6BFF'},


    // 设备上报运行工作状态(0x0005)
    {cnName: '设备运行工作状态', enName: 'deviceWorkState', keyWord: '0005',response: 'FE000880056F6BFF'},

    // 设备上报异常(0x0006)
    {cnName: '设备异常', enName: 'deviceError', keyWord: '0006',response: 'FE000880066F6BFF'},
    

    // 设备上报工作开始(0x0007)
    {cnName: '设备上报工作开始', enName: 'deviceWorkStart', keyWord: '0007',response: 'FE000880076F6BFF'},

    // 设备上报工作结束(0x0008)
    {cnName: '设备上报工作结束', enName: 'deviceWorkEnd', keyWord: '0008',response: 'FE000880086F6BFF'},

    // 设备上报工作结果(0x0009)
    {cnName: '设备上报工作结果', enName: 'deviceWorkResult', keyWord: '0009',response: 'FE000880096F6BFF'},
  ]
};